## llvm-toolchain-15 15.0.2

=== clang/lib/Basic/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  Support
  )

find_first_existing_vc_file("${LLVM_MAIN_SRC_DIR}" llvm_vc)
find_first_existing_vc_file("${CLANG_SOURCE_DIR}" clang_vc)

# The VC revision include that we want to generate.
set(version_inc "${CMAKE_CURRENT_BINARY_DIR}/VCSVersion.inc")

set(generate_vcs_version_script "${LLVM_CMAKE_DIR}/GenerateVersionFromVCS.cmake")

if(llvm_vc AND LLVM_APPEND_VC_REV)
  set(llvm_source_dir ${LLVM_MAIN_SRC_DIR})
endif()
if(clang_vc AND LLVM_APPEND_VC_REV)
  set(clang_source_dir ${CLANG_SOURCE_DIR})
endif()

# Create custom target to generate the VC revision include.
add_custom_command(OUTPUT "${version_inc}"
  DEPENDS "${llvm_vc}" "${clang_vc}" "${generate_vcs_version_script}"
  COMMAND ${CMAKE_COMMAND} "-DNAMES=\"LLVM;CLANG\""
                           "-DLLVM_SOURCE_DIR=${llvm_source_dir}"
                           "-DCLANG_SOURCE_DIR=${clang_source_dir}"
                           "-DHEADER_FILE=${version_inc}"
                           -P "${generate_vcs_version_script}")

# Mark the generated header as being generated.
set_source_files_properties("${version_inc}"
  PROPERTIES GENERATED TRUE
             HEADER_FILE_ONLY TRUE)

if(CLANG_VENDOR)
  set_source_files_properties(Version.cpp
    PROPERTIES COMPILE_DEFINITIONS "CLANG_VENDOR=\"${CLANG_VENDOR} \"")
endif()

add_clang_library(clangBasic
  Attributes.cpp
  Builtins.cpp
  CLWarnings.cpp
  CharInfo.cpp
  CodeGenOptions.cpp
  Cuda.cpp
  DarwinSDKInfo.cpp
  Diagnostic.cpp
  DiagnosticIDs.cpp
  DiagnosticOptions.cpp
  ExpressionTraits.cpp
  FileEntry.cpp
  FileManager.cpp
  FileSystemStatCache.cpp
  IdentifierTable.cpp
  LangOptions.cpp
  LangStandards.cpp
  MakeSupport.cpp
  Module.cpp
  ObjCRuntime.cpp
  OpenCLOptions.cpp
  OpenMPKinds.cpp
  OperatorPrecedence.cpp
  ProfileList.cpp
  NoSanitizeList.cpp
  SanitizerSpecialCaseList.cpp
  Sanitizers.cpp
  Sarif.cpp
  SourceLocation.cpp
  SourceManager.cpp
  Stack.cpp
  TargetID.cpp
  TargetInfo.cpp
  Targets.cpp
  Targets/AArch64.cpp
  Targets/AMDGPU.cpp
  Targets/ARC.cpp
  Targets/ARM.cpp
  Targets/AVR.cpp
  Targets/BPF.cpp
  Targets/CSKY.cpp
  Targets/DirectX.cpp
  Targets/Hexagon.cpp
  Targets/Lanai.cpp
  Targets/Le64.cpp
  Targets/M68k.cpp
  Targets/MSP430.cpp
  Targets/Mips.cpp
  Targets/NVPTX.cpp
  Targets/OSTargets.cpp
  Targets/PNaCl.cpp
  Targets/PPC.cpp
  Targets/RISCV.cpp
  Targets/SPIR.cpp
  Targets/Sparc.cpp
  Targets/SystemZ.cpp
  Targets/TCE.cpp
  Targets/VE.cpp
  Targets/WebAssembly.cpp
  Targets/X86.cpp
  Targets/XCore.cpp
  TokenKinds.cpp
  TypeTraits.cpp
  Version.cpp
  Warnings.cpp
  XRayInstr.cpp
  XRayLists.cpp
  ${version_inc}

  DEPENDS
  omp_gen
  )

## llvm-toolchain-15 15.0.0

=== debian/changelog ===
llvm-toolchain-15 (1:15.0.0-1~exp1) experimental; urgency=medium

  * New stable release
  * syscall-mips64el-def.diff: fix the call to undeclared function 'syscall';
    on mips

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 06 Sep 2022 09:13:19 +0200

llvm-toolchain-15 (1:15.0.0~+rc3-1~exp2) experimental; urgency=medium

  * Update of the build dep from llvm-spirv => llvm-spirv-14
    as it is now versionned. It should build libclc

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 31 Aug 2022 17:10:33 +0200

llvm-toolchain-15 (1:15.0.0~+rc3-1~exp1) experimental; urgency=medium

  * New snapshot release
  * For Debian Stretch for apt.llvm.org, use clang-14 to build
    itself as gcc 7 isn't available

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 25 Aug 2022 13:32:14 +0200

llvm-toolchain-15 (1:15.0.0~+rc2-1~exp1) experimental; urgency=medium

  * Second testing release of 15

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 09 Aug 2022 17:47:53 +0200

llvm-toolchain-15 (1:15.0.0~+rc1-1~exp1) experimental; urgency=medium

  * First testing release of 15
  * Remove 'debian/patches/revert-openmp-path.diff'
    applied upstream

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 01 Aug 2022 09:30:39 +0200

llvm-toolchain-15 (1:15~++20220727091640+d77882e66779-1~exp1) experimental; urgency=medium

  * main is now 16. Creating a branch for 15.
  * clang doesn't have a specific SONAME anymore.
    See https://reviews.llvm.org/D129160 for the rational

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 27 Jul 2022 09:27:50 +0200

llvm-toolchain-snapshot (1:15~++20220724113059+7feab85df8e8-1~exp1) experimental; urgency=medium

  * New snapshot release
  * Force the SSE2 on amd64 for compiler-rt/builtin:
    https://reviews.llvm.org/D107082#3626632
  * Ship llvm-debuginfod & llvm-dwarfutil in llvm-X.Y
  * Install usr/lib/llvm-15/lib/libomptarget.so.15 in libomp5-15
    And libomptarget.rtl.amdgpu.so.15, libomptarget.rtl.cuda.so.15 and
    libomptarget.rtl.x86_64.so.15
  * Add usr/lib/llvm-15/lib/libomptarget.devicertl.a to libomp-X-dev
    only for [amd64 ppc64el arm64]
  * On Debian Buster, unwind fails to link because pthread & dl aren't found.
    Force the declaration as it is probably the case for every Debian & Ubuntu anyway.
    See unwind-force-pthread-dl.diff & https://github.com/llvm/llvm-project/issues/55629
  * Install llvm-driver-template.cpp.in in llvm-X.Y-dev
  * Remove debian/patches/x86-fuzzer.patch (done differently upstream)
  * Install UnicodeNameMappingGenerator in llvm-X.Y-tools
  * Disable libclc when spir is below 14
    Explicit load/store type does not match pointee type of pointer operand (Producer: 'LLVM15.0.0' Reader: 'LLVM 13.0.1')
  * Add the option -DLLVM_ENABLE_CURL=ON
    See https://github.com/llvm/llvm-project/issues/55289
  * Install new binary clang-offload-packager in
    clang-tools-15

  [ John Paul Adrian Glaubitz ]
  * Enable GRPC build dependency only on supported targets
  * Disable compiler-rt built-ins on x32
  * Limit parallel link jobs for all stages on sparc and sparc64
  * Built compiler-rt for default target only on sparc and sparc64
  * Drop sparc64-specific patch D98574.patch
  * Drop sparc64-specific patch D98575.patch

  [ Roman Lebedev ]
  * Install new binary tblgen-lsp-server into mlir-15-tools

  [ Michael Biebl ]
  * Add support for systemd-binfmt (Closes: #1012370)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 24 Jul 2022 14:25:19 +0200

llvm-toolchain-snapshot (1:15~++20220309105819+8bef17ed59aa-1~exp1) experimental; urgency=medium

  * Try to unbreak the build (issue #54242)
    MLIR undef issue
  * New snapshot release

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 09 Mar 2022 22:58:29 +0100

llvm-toolchain-snapshot (1:15~++20220202093833+1a3137dc8451-1~exp1) experimental; urgency=medium

  * Install new llvm-remark-size-diff in llvm-X.Y
  * Install clang-pseudo in clang-tools-X.Y
  * mlir: use the cmake option to avoid installing object files
    MLIR_INSTALL_AGGREGATE_OBJECTS
    Closes upstream #53134
  * Build clangd with GRPC support
    Thanks to Sam McCall for the patch
  * snapshot is now 15. 14 is in it own branch now
  * Ship clang-linker-wrapper in clang-tools-X.Y

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 13 Feb 2022 23:25:57 +0100

llvm-toolchain-14 (1:14.0.6-3) UNRELEASED; urgency=medium

  * Fix a typo to silent lintian (Closes: #1018770)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 30 Aug 2022 16:10:33 +0200

llvm-toolchain-14 (1:14.0.6-2) unstable; urgency=medium

  [ Sam McCall ]
  * Add conventional symlink to libc++ headers in /usr/include/c++/v1
    See https://salsa.debian.org/pkg-llvm-team/llvm-toolchain/-/merge_requests/95
    for more information

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 23 Jul 2022 23:01:02 +0200

llvm-toolchain-14 (1:14.0.6-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 25 Jun 2022 09:56:23 +0200

llvm-toolchain-14 (1:14.0.5-1) unstable; urgency=medium

  * New upstream release
  * Only install grpc files libclang-X.Y-dev when grpc built
  * Remove cv-insn-support.patch (applied upstream)

  [ John Paul Adrian Glaubitz ]
  * Disable compiler-rt built-ins on x32

  [ Michael Biebl ]
  * Add support for systemd-binfmt (Closes: #1012368)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 11 Jun 2022 09:09:03 +0200

llvm-toolchain-14 (1:14.0.4-4) unstable; urgency=medium

  * autopkgtest: Restrict debian/qualify-clang.sh on
    amd64 arm64 i386

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 03 Jun 2022 10:52:10 +0200

llvm-toolchain-14 (1:14.0.4-3) unstable; urgency=medium

  * Fix GRPC installation path and files

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 31 May 2022 12:09:28 +0200

llvm-toolchain-14 (1:14.0.4-2) unstable; urgency=low

  * Add breaks/replaces for grpc binaries being placed in another package in Ubuntu
  * Fix GRPC installation for ports architectures


=== debian/control ===
Source: llvm-toolchain-15
Section: devel
Priority: optional
Rules-Requires-Root: no
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>, Gianfranco Costamagna <locutusofborg@debian.org>
Build-Depends: debhelper (>= 10.0), cmake, ninja-build,
    chrpath, texinfo, sharutils,
    libelf-dev,
    libffi-dev,
    lsb-release, patchutils, diffstat, xz-utils, python3-dev,
    libedit-dev, libncurses5-dev, swig, python3-six, python3-sphinx (>= 1.3.6),
    binutils-dev,
    libxml2-dev,
    libjsoncpp-dev, pkg-config,
    lcov, procps, help2man, zlib1g-dev,
    g++-multilib [amd64 i386 kfreebsd-amd64 mips64 mips64el mipsel powerpc ppc64 s390 s390x sparc sparc64 x32],
    libjs-mathjax, python3-recommonmark,
    doxygen, gfortran,
    ocaml-base [amd64 arm64 armhf ppc64el riscv64 s390x] | ocaml-nox [amd64 arm64 armhf ppc64el riscv64 s390x],
    ocaml-findlib [amd64 arm64 armhf ppc64el riscv64 s390x],
    libctypes-ocaml-dev [amd64 arm64 armhf ppc64el riscv64 s390x],
    dh-exec, dh-ocaml [amd64 arm64 armhf ppc64el riscv64 s390x],
    libpfm4-dev [linux-any], python3-setuptools, libz3-dev,
    llvm-spirv-14 [ amd64 arm64 armel armhf mips64el mipsel ppc64el s390x ] <!stage1> | hello [!i386],
    spirv-tools [ linux-any ] | hello [ !i386],
    libcurl4-dev,
    libgrpc++-dev [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x],
    protobuf-compiler-grpc [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x],
    libprotobuf-dev [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x],
    protobuf-compiler [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x]
# "| hello" is for older buster/bionic distros without spirv support
Build-Conflicts: oprofile
Standards-Version: 4.2.1
Homepage: https://www.llvm.org/
Vcs-Git: https://salsa.debian.org/pkg-llvm-team/llvm-toolchain.git -b 15
Vcs-Browser: https://salsa.debian.org/pkg-llvm-team/llvm-toolchain/tree/15

# ------------- clang -------------

Package: clang-15
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 ${dep:devlibs-objc}, libclang-common-15-dev (= ${binary:Version}),
 llvm-15-linker-tools (= ${binary:Version}),
 libclang1-15 (= ${binary:Version}), libc6-dev, binutils
Provides: c-compiler, objc-compiler, c++-compiler
Recommends: llvm-15-dev, python3
# libomp-15-dev
Suggests: clang-15-doc
Description: C, C++ and Objective-C compiler
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.

Package: clang-tools-15
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, clang-15 (= ${binary:Version}),
 python3
Description: clang-based tools for C/C++ developments
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains some clang-based tools like scan-build, clang-cl, etc.

Package: clang-format-15
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libllvm15 (= ${binary:Version})
Description: Tool to format C/C++/Obj-C code
 Clang-format is both a library and a stand-alone tool with the goal of
 automatically reformatting C++ sources files according to configurable
 style guides. To do so, clang-format uses Clang's Lexer to transform an
 input file into a token stream and then changes all the whitespace around
 those tokens. The goal is for clang-format to both serve both as a user
 tool (ideally with powerful IDE integrations) and part of other
 refactoring tools, e.g. to do a reformatting of all the lines changed
 during a renaming.
 .
 This package also provides vim and emacs plugins.

Package: clang-tidy-15
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3,
 libllvm15 (= ${binary:Version}), libclang-common-15-dev,
 clang-tools-15, python3-yaml
Description: clang-based C++ linter tool
 Provide an extensible framework for diagnosing and fixing typical programming
 errors, like style violations, interface misuse, or bugs that can be deduced
 via static analysis. clang-tidy is modular and provides a convenient interface
 for writing new checks.

Package: clangd-15
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libclang-common-15-dev (= ${binary:Version})
Description: Language server that provides IDE-like features to editors
 clangd understands your C++ code and adds smart features to your editor:
  - code completion
  - compile errors
  - go-to-definition
  - and more.
 .
 clangd is a language server that implements the Language Server Protocol;
 it can work with many editors through a plugin.

Package: clang-15-doc
Architecture: all
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-mathjax
Description: C, C++ and Objective-C compiler - Documentation
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the documentation.

Package: libclang1-15
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang library.
 .
 The C Interface to Clang provides a relatively small API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.

Package: libclang-15-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 ${dep:devlibs-objc}, libclang1-15 (= ${binary:Version}),
 libclang-common-15-dev (= ${binary:Version})
Description: Clang library - Development package
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang headers to develop extensions over
 libclang1-15.

Package: libclang-common-15-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, libllvm15 (= ${binary:Version})
Description: Clang library - Common development package
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang generic headers and some libraries
 (profiling, etc).

Package: libclang-cpp15
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libllvm15 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: C++ interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang C++ library.
 .
 The C++ Interface to Clang provides an API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.

Package: libclang-cpp15-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
 libclang-cpp15 (= ${binary:Version})
# Move of libclang-cpp.so into libclang-cpp15.dev
Description: C++ interface to the Clang library
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang C++ library.
 .
 The C++ Interface to Clang provides an API that exposes
 facilities for parsing source code into an abstract syntax tree (AST),
 loading already-parsed ASTs, traversing the AST, associating physical source
 locations with elements within the AST, and other facilities that support
 Clang-based development tools.
 .
 This package contains symlinks without a version number, which needed by
 linker at build time.


Package: libfuzzer-15-dev
Architecture: linux-any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, clang-15 (= ${binary:Version})
Description: Library for coverage-guided fuzz testing
 LibFuzzer is a library for in-process, coverage-guided, evolutionary fuzzing
 of other libraries.
 .
 LibFuzzer is similar in concept to American Fuzzy Lop (AFL), but it performs
 all of its fuzzing inside a single process. This in-process fuzzing can be
 more restrictive and fragile, but is potentially much faster as there is no
 overhead for process start-up.
 .
 The fuzzer is linked with the library under test, and feeds fuzzed inputs to
 the library via a specific fuzzing entrypoint (aka 'target function'); the
 fuzzer then tracks which areas of the code are reached, and generates mutations
 on the corpus of input data in order to maximize the code coverage. The code
 coverage information for libFuzzer is provided by LLVM's SanitizerCoverage
 instrumentation.


Package: python3-clang-15
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3, libclang-15-dev
Replaces: python-clang-x.y,
Conflicts: python-clang-x.y
Provides: python-clang-x.y
Description: Clang Python Bindings
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This binding package provides access to the Clang compiler and libraries.

Package: clang-15-examples
Architecture: any
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Clang examples
 Clang project is a C, C++, Objective C and Objective C++ front-end
 based on the LLVM compiler. Its goal is to offer a replacement to the
 GNU Compiler Collection (GCC).
 .
 Clang implements all of the ISO C++ 1998, 11, 14 and 17 standards and also
 provides most of the support of C++20.
 .
 This package contains the Clang examples.

# ------------- LLVM -------------

Package: libllvm15
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Modular compiler and toolchain technologies, runtime library
 LLVM is a collection of libraries and tools that make it easy to build

=== debian/rules ===
#!/usr/bin/make -f

# polly & lldb aren't enabled for every platform
PROJECTS = clang;clang-tools-extra;lld;cross-project-tests;mlir
# openmp & libunwind aren't enabled for every platform
RUNTIMES = compiler-rt;libcxx;libcxxabi

TARGET_BUILD	:= build-llvm
TARGET_BUILD_STAGE2    := $(TARGET_BUILD)/tools/clang/stage2-bins
DEB_INST		:= $(CURDIR)/debian/tmp/

GXX_VERSIONED_PACKAGE    := $(shell dpkg-query -W -f '$${Depends}' g++ | grep -o 'g++-[0-9][0-9.]*' | tail -n1 )
GXX_VERSIONED_EXECUTABLE := $(shell dpkg -L $(GXX_VERSIONED_PACKAGE) | grep '/usr/bin/g++-[0-9][0-9.]*' | xargs ls -d | tail -n1 )
GCC_VERSION              := $(subst /usr/bin/g++-,,$(GXX_VERSIONED_EXECUTABLE))

LLVM_VERSION   := $(shell dpkg-parsechangelog | sed -rne "s,^Version: 1:([0-9]+).*,\1,p")
LLVM_VERSION_FULL := $(shell dpkg-parsechangelog | sed -rne "s,^Version: 1:([0-9.]+)(~|-)(.*),\1,p")
LLVM_VERSION_SNAPSHOT := $(shell dpkg-parsechangelog | sed -rne "s,^Version: 1:(.*),\1,p")
ifeq ($(LLVM_VERSION),$(LLVM_VERSION_FULL))
	LLVM_VERSION_FULL := $(LLVM_VERSION).0.0
endif

SONAME_EXT      := 1
SONAME_OPENMP	:= 5
# Manage the case when the version is 3.5~svn213052-1~exp1 or 3.4.2-1
DEBIAN_REVISION := $(shell dpkg-parsechangelog |  sed -rne "s,^Version: 1:([0-9.]+)(~|-)(.*),\3,p")
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
else
  NJOBS := $(shell nproc)
endif

VENDOR=$(shell lsb_release -is)
DISTRO=$(shell lsb_release -sc)

DH_VERSION := $(shell dpkg -s debhelper | grep '^Version' | awk '{print $$2}')

include /usr/share/dpkg/architecture.mk

CONFIGURE_EXTRA =

# dpkg-buildflags support
# disable fixfilepath in favor of the llvm-project supplied flavor, disable lto
export DEB_BUILD_MAINT_OPTIONS = reproducible=-fixfilepath,-fixdebugpath optimize=-lto
# these are handled on a per stage / build basis
export DEB_CFLAGS_MAINT_STRIP = -g -O2
export DEB_CXXFLAGS_MAINT_STRIP = -g -O2

include /usr/share/dpkg/buildflags.mk

# We use a stage2 build. It means that a first clang is built using gcc,
# a second clang is built with the first
# And the various compoments are built using the second clang.
# See https://llvm.org/docs/AdvancedBuilds.html

# collect additional flags for all stages all builds
CFLAGS_EXTRA = -Wno-unused-command-line-argument
CXXFLAGS_EXTRA = -Wno-unused-command-line-argument
LDFLAGS_EXTRA = -Wl,--build-id

# collect all flags for stage 1 toolchain build only
STAGE_1_CFLAGS = $(CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS)
STAGE_1_CXXFLAGS = $(CXXFLAGS) $(CXXFLAGS_EXTRA) $(CPPFLAGS)
STAGE_1_LDFLAGS = $(LDFLAGS) $(LDFLAGS_EXTRA)

# collect all flags for stage 2 toolchain and stand-alone builds
STAGE_2_CFLAGS = $(CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS)
STAGE_2_CXXFLAGS = $(CXXFLAGS) $(CXXFLAGS_EXTRA) $(CPPFLAGS)
STAGE_2_LDFLAGS = $(LDFLAGS) $(LDFLAGS_EXTRA)

# collect additional cmake options for toolchain build configuration
STAGE_1_CMAKE_EXTRA =
STAGE_2_CMAKE_EXTRA =
STAGE_ALL_CMAKE_EXTRA =
# toolchain config-only var combining all stage 1 cmake options
CMAKE_EXTRA = $(STAGE_1_CMAKE_EXTRA) $(STAGE_ALL_CMAKE_EXTRA)
# toolchain config-only var prepending BOOTSTRAP_ to all stage 2 cmake options
BOOTSTRAP_CMAKE_EXTRA = $(foreach extra,$(STAGE_2_CMAKE_EXTRA) $(STAGE_ALL_CMAKE_EXTRA), $(subst -D,-DBOOTSTRAP_,$(extra)))

BASE_PATH := $(CURDIR)
STAGE_1_BIN_DIR := $(BASE_PATH)/$(TARGET_BUILD)/bin
STAGE_1_LIB_DIR := $(BASE_PATH)/$(TARGET_BUILD)/lib
STAGE_2_BIN_DIR := $(BASE_PATH)/$(TARGET_BUILD_STAGE2)/bin
STAGE_2_LIB_DIR := $(BASE_PATH)/$(TARGET_BUILD_STAGE2)/lib

# toggleable defaults
COMPILER_RT_USE_BUILTINS_LIBRARY := ON
LIBCXX_EXCEPTIONS := ON
LIBCXX_USE_COMPILER_RT := ON

ifneq (,$(filter $(DEB_HOST_ARCH),i386 hurd-i386 kfreebsd-i386 armel mipsel powerpc powerpcspe riscv64))
# For some reason, in the stage2 build, when clang is used to compile
# itself. The atomic detection is failing on armel and riscv64. Forcing the inclusion
# everywhere and in all stages
LDFLAGS_EXTRA += -latomic
endif

ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' g++-$(GCC_VERSION)) lt 4.9-20140411-1~ ; echo $$?),0)
# Too old version of gcc. Force 4.9
	GCC_VERSION := 4.9
endif

ifneq (,$(filter $(DISTRO),stretch))
# from llvm 15, we need gcc at least 7
# No need for now. keeping in case we do in the future
#  GCC_VERSION := 7
# Don't enable lld python for old distros
  STAGE_ALL_CMAKE_EXTRA += -DLLDB_ENABLE_PYTHON=OFF
  USE_CLANG_PACKAGE_TO_BUILD_ITSELF = yes
endif

Z3_FLAG = -DLLVM_ENABLE_Z3_SOLVER=OFF
ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' libz3-dev) gt 4.7.0; echo $$?),0)
# no ocaml support in main for Ubuntu
ifneq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
	Z3_FLAG = -DLLVM_ENABLE_Z3_SOLVER=ON
endif
endif
STAGE_2_CMAKE_EXTRA += $(Z3_FLAG)

# Change the default CPU for s390x
ZARCH=z196
ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
ZARCH=z13
endif
STAGE_2_CMAKE_EXTRA += -DCLANG_SYSTEMZ_DEFAULT_ARCH=$(ZARCH)

# clangd remote index support requires GRPC & protobuf.
# Enable if minimum tested versions are available.
CLANGD_GRPC_INSTALLED=no
ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' libgrpc++-dev) gt 1.30.0; echo $$?),0)
ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' protobuf-compiler-grpc) gt 1.30.0; echo $$?),0)
ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' libprotobuf-dev) gt 3.12.0; echo $$?),0)
ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' protobuf-compiler) gt 3.12.0; echo $$?),0)
CLANGD_GRPC_INSTALLED=yes
STAGE_2_CMAKE_EXTRA += -DCLANGD_ENABLE_REMOTE=ON
endif
endif
endif
endif

ifeq ($(USE_CLANG_PACKAGE_TO_BUILD_ITSELF),yes)
# For Debian stretch, gcc isn't available, let's use clang
# itself to build itself.
export CC=clang-14
export CXX=clang++-14
else
export CC=gcc-$(GCC_VERSION)
export CXX=g++-$(GCC_VERSION)
endif

opt_flags = -O2 -DNDEBUG -g1

ifneq (,$(findstring $(DEB_HOST_ARCH),armel))
  STAGE_ALL_CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=arm-linux-gnueabi
  STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_DEFAULT_TARGET_ONLY=ON
# align arch profile with debian baseline
# https://wiki.debian.org/ArmEabiPort
  CFLAGS_EXTRA += -march=armv5t
  CXXFLAGS_EXTRA += -march=armv5t
# disable compiler-rt builtins (not supported for baseline armel arch: armv5t)
# See http://lists.llvm.org/pipermail/llvm-dev/2016-May/099761.html
  STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_BUILD_BUILTINS=OFF
  COMPILER_RT_USE_BUILTINS_LIBRARY := OFF
  LIBCXX_USE_COMPILER_RT := OFF
# disable scudo standalone (not supported for baseline armel arch: armv5t)
  STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_BUILD_SCUDO_STANDALONE=OFF
endif

ifneq (,$(findstring $(DEB_HOST_ARCH),armhf))
  STAGE_ALL_CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=arm-linux-gnueabihf
  STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_DEFAULT_TARGET_ONLY=ON
# align arch profile with debian baseline
# https://wiki.debian.org/ArmHardFloatPort#Minimum_CPU_.26_FPU
  CFLAGS_EXTRA += -march=armv7-a -mfpu=vfpv3-d16
  CXXFLAGS_EXTRA += -march=armv7-a -mfpu=vfpv3-d16
endif

ifneq (,$(filter $(DEB_HOST_ARCH),i386))
# Sometimes, i386 needs help with the triple
  STAGE_ALL_CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=i386-linux-gnu
endif

ifneq (,$(filter $(DEB_HOST_ARCH),i386))
# Sometimes, i386 needs help with the triple
  CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=i386-linux-gnu
endif



ifneq (,$(filter $(DEB_HOST_ARCH),mips64el))
# avoid an issue with search path on mips64el
# https://bugs.llvm.org/show_bug.cgi?id=41204
  STAGE_ALL_CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=mips64el-linux-gnuabi64
endif

ifneq (,$(filter $(DEB_HOST_ARCH),powerpc))
  STAGE_ALL_CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=powerpc-linux-gnu
  STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_DEFAULT_TARGET_ONLY=ON
endif

ifneq (,$(filter $(DEB_HOST_ARCH),sparc))
  STAGE_ALL_CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=sparc-linux-gnu

## llvm-toolchain-15 15.0.2

=== debian/changelog ===
llvm-toolchain-15 (1:15.0.2-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 04 Oct 2022 15:19:24 +0200

llvm-toolchain-15 (1:15.0.1-1) unstable; urgency=medium

  * Upload to unstable now that we have removed 12 from the archive

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 04 Oct 2022 09:24:55 +0200

llvm-toolchain-15 (1:15.0.1-1~exp2) experimental; urgency=medium

  * Unbreak the clang symlink. See
    https://github.com/llvm/llvm-project/issues/57857

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 21 Sep 2022 00:20:54 +0200

llvm-toolchain-15 (1:15.0.1-1~exp1) experimental; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 20 Sep 2022 08:55:01 +0200

llvm-toolchain-15 (1:15.0.0-2) experimental; urgency=medium

  * Fix build on ppc64 and riscv64 (Closes: #1019582)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 12 Sep 2022 17:58:08 +0200

## llvm-toolchain-15 15.0.5

=== debian/changelog ===
llvm-toolchain-15 (1:15.0.5-4) unstable; urgency=medium

  * Explicitly depend on spirv-14 for riscv64, to bootstrap spirv there.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 22 Nov 2022 10:58:27 +0100

llvm-toolchain-15 (1:15.0.5-3) unstable; urgency=medium

  * Depend again on spirv-15 for mips64el.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 20 Nov 2022 06:54:23 +0100

llvm-toolchain-15 (1:15.0.5-2) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Add libomp target library to mips64el (Closes: #1023101)
  * Explictly depend on spirv-14 for mips64el, to ease bootstrapping
    on buildds (this should be dropped once we build a spirv-15 in archive)
  * Cherry-pick two upstream patches to unblock mesa build on arm* (Closes:
    #1022577)

  [ Sylvestre Ledru ]
  * store the sccache results in /tmp/buildd/source/sccache-stats.json

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 19 Nov 2022 23:25:04 +0100

llvm-toolchain-15 (1:15.0.5-1) unstable; urgency=medium

  * New upstream release
  * Remove the swig patches (applied upstream)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 16 Nov 2022 09:11:01 +0100

llvm-toolchain-15 (1:15.0.4-1) unstable; urgency=medium

  [ Jordan Justen ]
  * d/rules: Rename LLVM_SPIR_VERSION to LLVM_SPIRV_VERSION
  * d/rules: Call bash to use 'command -v' to locate llvm-spirv executable
  * debian: Bump llvm-spirv to 15 to match the llvm version
  * d/rules: Set LLVM_SPIRV with cmake for libclc
  * d/patches: Drop libclc-llvm-spirv.diff now that we are setting LLVM_SPIRV
  * d/rules: Restore building libclc .bc output without spir-v support
  * d/rules: Check for previous version of llvm-spirv as well
  * d/control: Add llvm-spirv-14 as an alternative to llvm-spirv-15

  [ Sylvestre Ledru ]
  * New upstream release (Closes: #1023455)
  * Cherry-pick patches to fix the FTBFS with swig + lldb (Closes: #1023444)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 02 Nov 2022 08:50:23 +0100

llvm-toolchain-15 (1:15.0.3-2) unstable; urgency=medium

  * Cherry-pick upstream fix to unbreak mips (closes: #1022169)
    Thanks to YunQiang Su for the patch
    https://reviews.llvm.org/D135553

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 28 Oct 2022 10:25:45 +0200

llvm-toolchain-15 (1:15.0.3-1) unstable; urgency=medium

  * Upload to unstable now that autopkgtest is green

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 23 Oct 2022 10:34:58 +0200

llvm-toolchain-15 (1:15.0.3-1~exp2) experimental; urgency=medium

  * Fix autopkgtest (remove move stuff from the cmake search)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 21 Oct 2022 23:53:23 +0200

llvm-toolchain-15 (1:15.0.3-1~exp1) experimental; urgency=medium

  * New stable release

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 18 Oct 2022 14:04:32 +0200

llvm-toolchain-15 (1:15.0.2-2~exp6) experimental; urgency=medium

  * Disable LTO for now
  * don't search for llvm-bolt, merge-fdata, etc in cmake
    https://github.com/llvm/llvm-project/issues/58317

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 12 Oct 2022 16:19:03 +0200

llvm-toolchain-15 (1:15.0.2-2~exp5) experimental; urgency=medium

  * Only enable LTO for some archs

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 11 Oct 2022 09:15:56 +0200

llvm-toolchain-15 (1:15.0.2-2~exp4) experimental; urgency=medium

  * Only ship libbolt_rt_hugify.a & libbolt_rt_instr.a on amd64
  * fix the cmake detection with libmlir

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 09 Oct 2022 20:09:46 +0200

llvm-toolchain-15 (1:15.0.2-2~exp3) experimental; urgency=medium

  * Build using LTO - better performances of the llvm-toolchain
    binaires
  * Build libfuzzer with C++ 17 ot unbreak it

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 08 Oct 2022 15:06:37 +0200

llvm-toolchain-15 (1:15.0.2-2~exp2) experimental; urgency=medium

  * Fix a typo to silent lintian (Closes: #1018770)
  * Fix some hardcoded paths (Closes: #1020847)
  * Suggest wasi-libc for clang

  [ Witold Baryluk ]
  * Allow libunwind-dev to be coinstallable (Closes: #1004112)

  [ Faidon Liambotis ]
  * Add better support for the WebAssembly (wasm32/wasm64) targets:
    - Ship compiler-rt for the wasm32 and wasm64 targets. (Closes: #1010932)
    - Add patch wasm-compiler-rt-default.diff to default to compiler-rt for
      these targets. libgcc does not currently exist for WebAssembly in neither
      Debian nor upstream, and therefore compiler-rt is the only option.
    - Add patch wasm-sysroot-usr.diff to support a system-installed (i.e. shipped
      in /usr) wasi-libc. (Closes: #1020746)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 06 Oct 2022 17:04:24 +0200

llvm-toolchain-15 (1:15.0.2-2~exp1) experimental; urgency=medium

  * Ship bolt

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 04 Oct 2022 15:21:19 +0200

llvm-toolchain-14 (1:14.0.6-9) unstable; urgency=medium

  * Disable the MLIR testsuite run because of a freeze
    (Closes: #1024154)
    See https://github.com/llvm/llvm-project/issues/58357

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 15 Nov 2022 18:23:44 +0100

llvm-toolchain-14 (1:14.0.6-8) unstable; urgency=medium

  * Fix the lldb swig issues (closes: #1023444)
  * Enable LLVM_USE_RELATIVE_PATHS_IN_DEBUG_INFO to help with caching
  * Adjust to protobuf 3.21 (Closes: #1023533)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 04 Nov 2022 19:36:56 +0100

llvm-toolchain-14 (1:14.0.6-7) unstable; urgency=medium

  * Disable the cmake search for all binaries
    (cmake_import_check_files_for.*/bin/). Dunno why it regressed
    but we wasted too much time on this.
  * disable sccache on bionic

  [ Jordan Justen ]
  * d/rules: Call bash to use 'command -v' to location llvm-spirv executable
  * d/rules: Set LLVM_SPIRV with cmake for libclc
  * d/patches: Drop libclc-llvm-spirv.diff now that we are setting LLVM_SPIRV
  * d/rules: Check for llvm-spirv with version suffix



=== debian/control ===
--- 
+++ 
@@ -22,7 +22,9 @@
     libctypes-ocaml-dev [amd64 arm64 armhf ppc64el riscv64 s390x],
     dh-exec, dh-ocaml [amd64 arm64 armhf ppc64el riscv64 s390x],
     libpfm4-dev [linux-any], python3-setuptools, libz3-dev,
+    llvm-spirv-15 [ amd64 arm64 armel armhf mips64el mipsel ppc64el s390x ] <!stage1> |
     llvm-spirv-14 [ amd64 arm64 armel armhf mips64el mipsel ppc64el s390x ] <!stage1> | hello [!i386],
+    llvm-spirv-14 [ riscv64 ] <!stage1>,
     spirv-tools [ linux-any ] | hello [ !i386],
     libcurl4-dev,
     libgrpc++-dev [amd64 arm64 armel armhf mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x],
@@ -47,7 +49,7 @@
 Provides: c-compiler, objc-compiler, c++-compiler
 Recommends: llvm-15-dev, python3
 # libomp-15-dev
-Suggests: clang-15-doc
+Suggests: clang-15-doc, wasi-libc
 Description: C, C++ and Objective-C compiler
  Clang project is a C, C++, Objective C and Objective C++ front-end
  based on the LLVM compiler. Its goal is to offer a replacement to the
@@ -286,4 +288,3 @@
 Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: same
 Description: Modular compiler and toolchain technologies, runtime library
- LLVM is a collection of libraries and tools that make it easy to build

=== debian/rules ===
--- 
+++ 
@@ -25,7 +25,7 @@
 # Manage the case when the version is 3.5~svn213052-1~exp1 or 3.4.2-1
 DEBIAN_REVISION := $(shell dpkg-parsechangelog |  sed -rne "s,^Version: 1:([0-9.]+)(~|-)(.*),\3,p")
 ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
-  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
+  NJOBS := $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
 else
   NJOBS := $(shell nproc)
 endif
@@ -50,7 +50,7 @@
 
 # We use a stage2 build. It means that a first clang is built using gcc,
 # a second clang is built with the first
-# And the various compoments are built using the second clang.
+# And the various components are built using the second clang.
 # See https://llvm.org/docs/AdvancedBuilds.html
 
 # collect additional flags for all stages all builds
@@ -88,25 +88,21 @@
 LIBCXX_EXCEPTIONS := ON
 LIBCXX_USE_COMPILER_RT := ON
 
+# We want to set the clang extra version ONLY in stage 2
+# because we want the clang stage 1 to be as reproducible as possible
+# when building with sccache (because this tool do a hash using the
+# compiler binary and other things)
+STAGE_2_CMAKE_EXTRA += -DCLANG_REPOSITORY_STRING=$(DEBIAN_REVISION)
+
+ifneq (,$(filter $(DEB_HOST_ARCH),sparc sparc64))
+STAGE_1_CMAKE_EXTRA += -DLLVM_PARALLEL_LINK_JOBS=4
+endif
+
 ifneq (,$(filter $(DEB_HOST_ARCH),i386 hurd-i386 kfreebsd-i386 armel mipsel powerpc powerpcspe riscv64))
 # For some reason, in the stage2 build, when clang is used to compile
 # itself. The atomic detection is failing on armel and riscv64. Forcing the inclusion
 # everywhere and in all stages
 LDFLAGS_EXTRA += -latomic
-endif
-
-ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' g++-$(GCC_VERSION)) lt 4.9-20140411-1~ ; echo $$?),0)
-# Too old version of gcc. Force 4.9
-	GCC_VERSION := 4.9
-endif
-
-ifneq (,$(filter $(DISTRO),stretch))
-# from llvm 15, we need gcc at least 7
-# No need for now. keeping in case we do in the future
-#  GCC_VERSION := 7
-# Don't enable lld python for old distros
-  STAGE_ALL_CMAKE_EXTRA += -DLLDB_ENABLE_PYTHON=OFF
-  USE_CLANG_PACKAGE_TO_BUILD_ITSELF = yes
 endif
 
 Z3_FLAG = -DLLVM_ENABLE_Z3_SOLVER=OFF
@@ -201,3 +197,4 @@
 
 ifneq (,$(filter $(DEB_HOST_ARCH),sparc))
   STAGE_ALL_CMAKE_EXTRA += -DLLVM_HOST_TRIPLE=sparc-linux-gnu
+  STAGE_ALL_CMAKE_EXTRA += -DCOMPILER_RT_DEFAULT_TARGET_ONLY=ON
